// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QREditor.pas' rev: 5.00

#ifndef QREditorHPP
#define QREditorHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ImgList.hpp>	// Pascal unit
#include <DBTables.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Buttons.hpp>	// Pascal unit
#include <ToolWin.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Qrctrls.hpp>	// Pascal unit
#include <QuickRpt.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qreditor
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TGrabPosition { gpN, gpNE, gpE, gpSE, gpS, gpSW, gpW, gpNW };
#pragma option pop

class DELPHICLASS TGrabHandle;
class PASCALIMPLEMENTATION TGrabHandle : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	TGrabPosition FPosition;
	int FSize;
	Controls::TControl* FParentControl;
	bool FDim;
	int Offset;
	void __fastcall SetSize(int Value);
	void __fastcall SetDim(bool Value);
	HIDESBASE void __fastcall SetCursor(void);
	
protected:
	virtual void __fastcall Paint(void);
	
public:
	__fastcall TGrabHandle(Classes::TComponent* AOwner, Controls::TControl* ParentControl, TGrabPosition 
		Position);
	__property int Size = {read=FSize, write=SetSize, nodefault};
	__property bool Dim = {read=FDim, write=SetDim, nodefault};
	void __fastcall UpdatePosition(void);
public:
	#pragma option push -w-inl
	/* TCustomControl.Create */ inline __fastcall virtual TGrabHandle(Classes::TComponent* AOwner) : Controls::TCustomControl(
		AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomControl.Destroy */ inline __fastcall virtual ~TGrabHandle(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TGrabHandle(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TFocusFrameState { fsNormal, fsDim, fsFrame };
#pragma option pop

class DELPHICLASS TFocusFrame;
class PASCALIMPLEMENTATION TFocusFrame : public Controls::TWinControl 
{
	typedef Controls::TWinControl inherited;
	
private:
	Windows::TRect CurrentRect;
	Classes::TList* GrabHandles;
	Controls::TControl* FParentControl;
	TFocusFrameState FState;
	void __fastcall SetState(TFocusFrameState Value);
	void __fastcall PaintFrame(void);
	
public:
	__fastcall TFocusFrame(Classes::TComponent* AOwner, Controls::TControl* ParentControl);
	__fastcall virtual ~TFocusFrame(void);
	void __fastcall SizeFrame(int ALeft, int AUp, int ARight, int ADown);
	void __fastcall MoveFrame(int ALeft, int AUp);
	void __fastcall UpdateGrabHandles(void);
	__property TFocusFrameState State = {read=FState, write=SetState, nodefault};
public:
	#pragma option push -w-inl
	/* TWinControl.Create */ inline __fastcall virtual TFocusFrame(Classes::TComponent* AOwner) : Controls::TWinControl(
		AOwner) { }
	#pragma option pop
	
};


class DELPHICLASS TSelectionList;
class DELPHICLASS TCustomEditor;
typedef TMetaClass*TNewComponentClass;

#pragma option push -b-
enum TEditorState { esNormal, esResize, esMove, esAdd };
#pragma option pop

class PASCALIMPLEMENTATION TCustomEditor : public Extctrls::TCustomPanel 
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	TSelectionList* FSelectionList;
	bool FEditing;
	bool MouseIsDown;
	Classes::TStream* Clipboard;
	bool SizeUp;
	bool SizeDown;
	bool SizeLeft;
	bool SizeRight;
	Windows::TPoint Origin;
	TMetaClass*NewComponentClass;
	bool FClipboardAvailable;
	Controls::TWinControl* FMainControl;
	TEditorState FState;
	Classes::TNotifyEvent FOnAddedControl;
	Classes::TNotifyEvent FOnSelectControl;
	Classes::TNotifyEvent FOnUnselectControl;
	Classes::TNotifyEvent FOnClipboardStateChange;
	Classes::TNotifyEvent FOnModified;
	bool FModified;
	
protected:
	virtual void __fastcall DoAdd(int X, int Y);
	virtual void __fastcall DoPopup(int X, int Y);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall SetEditing(bool Value);
	virtual void __fastcall MouseDownHandler(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	virtual void __fastcall MouseMoveHandler(System::TObject* Sender, Classes::TShiftState Shift, int X
		, int Y);
	virtual void __fastcall MouseUpHandler(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	virtual void __fastcall StartResize(TGrabPosition Position, const Windows::TPoint &APoint);
	virtual void __fastcall ResizeTo(const Windows::TPoint &APoint);
	virtual void __fastcall EndResize(const Windows::TPoint &APoint);
	virtual void __fastcall StartMove(const Windows::TPoint &APoint);
	virtual void __fastcall MoveTo(const Windows::TPoint &APoint);
	virtual void __fastcall EndMove(const Windows::TPoint &APoint);
	virtual void __fastcall SetModified(bool Value);
	__property TEditorState State = {read=FState, nodefault};
	
public:
	__fastcall virtual TCustomEditor(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomEditor(void);
	void __fastcall AddClass(TMetaClass* ComponentClass);
	void __fastcall Add(Classes::TComponent* AComponent, Controls::TWinControl* AParent);
	void __fastcall ClearAll(void);
	virtual void __fastcall Select(Controls::TControl* AControl, bool MultiSelect);
	virtual void __fastcall Unselect(Controls::TControl* AControl);
	virtual void __fastcall UnselectAll(void);
	virtual void __fastcall DeleteSelected(void);
	void __fastcall CopySelected(void);
	void __fastcall CutSelected(void);
	void __fastcall Paste(void);
	void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall Save(AnsiString Filename);
	void __fastcall SetEvents(Controls::TWinControl* AControl);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	void __fastcall Load(AnsiString Filename);
	__property bool ClipboardAvailable = {read=FClipboardAvailable, nodefault};
	__property TSelectionList* SelectionList = {read=FSelectionList};
	__property bool Editing = {read=FEditing, write=SetEditing, nodefault};
	__property Controls::TWinControl* MainControl = {read=FMainControl, write=FMainControl};
	__property bool Modified = {read=FModified, write=SetModified, nodefault};
	
__published:
	__property Classes::TNotifyEvent OnAddedControl = {read=FOnAddedControl, write=FOnAddedControl};
	__property Classes::TNotifyEvent OnSelectControl = {read=FOnSelectControl, write=FOnSelectControl};
		
	__property Classes::TNotifyEvent OnUnselectControl = {read=FOnUnselectControl, write=FOnUnselectControl
		};
	__property Classes::TNotifyEvent OnClipboardStateChange = {read=FOnClipboardStateChange, write=FOnClipboardStateChange
		};
	__property Classes::TNotifyEvent OnModified = {read=FOnModified, write=FOnModified};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TCustomEditor(HWND ParentWindow) : Extctrls::TCustomPanel(
		ParentWindow) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TSelectionList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TList* ControlList;
	Classes::TList* FocusList;
	TFocusFrameState FState;
	TCustomEditor* FEditor;
	int MovedUp;
	int MovedLeft;
	int SizedUp;
	int SizedDown;
	int SizedLeft;
	int SizedRight;
	
protected:
	void __fastcall SetState(TFocusFrameState Value);
	void __fastcall FindMaxValues(int &ALeft, int &ATop, int &ARight, int &ABottom);
	void __fastcall AlignTo(TGrabPosition Position);
	int __fastcall GetCount(void);
	Controls::TControl* __fastcall GetItem(int Index);
	
public:
	__fastcall TSelectionList(void);
	__fastcall virtual ~TSelectionList(void);
	void __fastcall AlignLefts(void);
	void __fastcall AlignRights(void);
	void __fastcall AlignTops(void);
	void __fastcall AlignBottoms(void);
	void __fastcall Add(Controls::TControl* AControl);
	void __fastcall Remove(Controls::TControl* AControl);
	void __fastcall Clear(void);
	void __fastcall Size(int ALeft, int AUp, int ARight, int ADown);
	void __fastcall Move(int ALeft, int AUp);
	void __fastcall BringToFront(void);
	void __fastcall SendToBack(void);
	void __fastcall Copy(Classes::TStream* &Stream);
	void __fastcall UnselectChildren(void);
	bool __fastcall UpdateControls(void);
	bool __fastcall IsSelected(Controls::TControl* AControl);
	__property Controls::TControl* Items[int index] = {read=GetItem/*, default*/};
	__property TFocusFrameState State = {read=FState, write=SetState, nodefault};
	__property int Count = {read=GetCount, nodefault};
	__property TCustomEditor* Editor = {read=FEditor, write=FEditor};
};


class DELPHICLASS TQRCustomComponentEditor;
class PASCALIMPLEMENTATION TQRCustomComponentEditor : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	virtual AnsiString __fastcall GetName(void) = 0 ;
	virtual Graphics::TBitmap* __fastcall GetBitmap(void) = 0 ;
	
public:
	virtual void __fastcall Popup(void) = 0 ;
	virtual void __fastcall Edit(void) = 0 ;
	virtual void __fastcall Settings(void) = 0 ;
	__property AnsiString Name = {read=GetName};
	__property Graphics::TBitmap* Bitmap = {read=GetBitmap};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TQRCustomComponentEditor(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TQRCustomComponentEditor(void) { }
	#pragma option pop
	
};


class DELPHICLASS TQRCustomEditor;
class PASCALIMPLEMENTATION TQRCustomEditor : public TCustomEditor 
{
	typedef TCustomEditor inherited;
	
__published:
	__property Align ;
	__property OnSelectControl ;
	__property OnUnselectControl ;
	__property OnClipboardStateChange ;
	__property OnModified ;
public:
	#pragma option push -w-inl
	/* TCustomEditor.Create */ inline __fastcall virtual TQRCustomEditor(Classes::TComponent* AOwner) : 
		TCustomEditor(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomEditor.Destroy */ inline __fastcall virtual ~TQRCustomEditor(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TQRCustomEditor(HWND ParentWindow) : TCustomEditor(
		ParentWindow) { }
	#pragma option pop
	
};


class DELPHICLASS TQReportEditor;
class PASCALIMPLEMENTATION TQReportEditor : public Forms::TForm 
{
	typedef Forms::TForm inherited;
	
__published:
	Extctrls::TPanel* MainPanel;
	Forms::TScrollBox* ScrollArea;
	Comctrls::TCoolBar* CoolBar1;
	Comctrls::TToolBar* FileTB;
	Comctrls::TToolButton* NewBtn;
	Comctrls::TToolButton* OpenBtn;
	Comctrls::TToolButton* SaveBtn;
	Comctrls::TToolButton* ToolButton4;
	Comctrls::TToolButton* PrintBtn;
	Comctrls::TToolButton* PreviewBtn;
	Comctrls::TToolButton* ToolButton7;
	Comctrls::TToolButton* CutBtn;
	Comctrls::TToolButton* CopyBtn;
	Comctrls::TToolButton* PasteBtn;
	Comctrls::TToolBar* AttributeTB;
	Stdctrls::TComboBox* FontNameCB;
	Comctrls::TToolButton* ToolButton12;
	Stdctrls::TComboBox* FontSizeCB;
	Comctrls::TToolButton* ToolButton13;
	Comctrls::TToolButton* BoldBtn;
	Comctrls::TToolButton* ItalicBtn;
	Comctrls::TToolButton* UnderLnBtn;
	Comctrls::TToolButton* ToolButton17;
	Comctrls::TToolButton* LeftAlBtn;
	Comctrls::TToolButton* CenterAlBtn;
	Comctrls::TToolButton* RightAlBtn;
	Comctrls::TToolButton* ToolButton21;
	Comctrls::TToolBar* ComponentsTB;
	Comctrls::TToolBar* ControlTB;
	Comctrls::TToolButton* ControlOKBtn;
	Comctrls::TToolButton* ControlCancelBtn;
	Comctrls::TToolButton* ToolButton6;
	Stdctrls::TEdit* ControlValue;
	Comctrls::TToolButton* ControlEditBtn;
	Comctrls::TToolButton* ToolButton1;
	Comctrls::TStatusBar* StatusBar;
	Menus::TMainMenu* MainMenu;
	Menus::TMenuItem* Insert1;
	Menus::TMenuItem* NewMI;
	Menus::TMenuItem* OpenMI;
	Menus::TMenuItem* SaveMI;
	Menus::TMenuItem* SaveAsMI;
	Menus::TMenuItem* load1;
	Menus::TMenuItem* ReportSetupMI;
	Menus::TMenuItem* PreviewMI;
	Menus::TMenuItem* PrintMI;
	Menus::TMenuItem* N1;
	Menus::TMenuItem* ExitMI;
	Menus::TMenuItem* View1;
	Menus::TMenuItem* CutMI;
	Menus::TMenuItem* CopyMI;
	Menus::TMenuItem* PasteMI;
	Menus::TMenuItem* N2;
	Menus::TMenuItem* ClearMI;
	Menus::TMenuItem* SelectAllMI;
	Menus::TMenuItem* Data1;
	Menus::TMenuItem* SelectDataMI;
	Menus::TMenuItem* AddChildtable1;
	Controls::TImageList* NormalImages;
	Comctrls::TToolButton* SettingsBtn;
	Comctrls::TToolButton* DataSetupBtn;
	void __fastcall FormKeyDown(System::TObject* Sender, Word &Key, Classes::TShiftState Shift);
	void __fastcall OpenMIClick(System::TObject* Sender);
	void __fastcall EditorSelectControl(System::TObject* Sender);
	void __fastcall EditorClipboardStateChange(System::TObject* Sender);
	void __fastcall ControlTBResize(System::TObject* Sender);
	void __fastcall ControlValueEnter(System::TObject* Sender);
	void __fastcall ControlValueExit(System::TObject* Sender);
	void __fastcall FormCreate(System::TObject* Sender);
	void __fastcall BtnClick(System::TObject* Sender);
	void __fastcall EditorAddedControl(System::TObject* Sender);
	void __fastcall FormActivate(System::TObject* Sender);
	void __fastcall FontNameCBChange(System::TObject* Sender);
	void __fastcall ControlValueKeyPress(System::TObject* Sender, char &Key);
	
private:
	AnsiString FFilename;
	bool FDesignTime;
	Classes::TList* ControlEditors;
	TQRCustomEditor* __fastcall GetFormEditor(void);
	
protected:
	TQRCustomEditor* Editor;
	void __fastcall SetFilename(AnsiString Value);
	void __fastcall EnableAndDisable(void);
	void __fastcall CreateComponentButtons(void);
	void __fastcall AddControlClick(System::TObject* Sender);
	void __fastcall SetStyle(System::TObject* Sender);
	void __fastcall SetValue(void);
	void __fastcall CancelValue(void);
	void __fastcall SetDesignTime(bool Value);
	bool __fastcall EditControl(Quickrpt::TQRPrintable* AQRPrintable);
	Quickrpt::TQRPrintableEditor* __fastcall PrintableEditor(void);
	
public:
	__property bool DesignTime = {read=FDesignTime, write=SetDesignTime, nodefault};
	__property AnsiString Filename = {read=FFilename, write=SetFilename};
	__property TQRCustomEditor* FormEditor = {read=GetFormEditor};
	void __fastcall ShowEditor(void);
	void __fastcall NewReport(void);
	void __fastcall OpenReport(void);
	void __fastcall SaveReport(void);
	void __fastcall PrintReport(void);
	void __fastcall PreviewReport(void);
	void __fastcall SaveReportAs(void);
	void __fastcall ReportSettings(void);
	void __fastcall SelectData(void);
	void __fastcall Cut(void);
	void __fastcall Copy(void);
	void __fastcall Paste(void);
public:
	#pragma option push -w-inl
	/* TCustomForm.Create */ inline __fastcall virtual TQReportEditor(Classes::TComponent* AOwner) : Forms::TForm(
		AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomForm.CreateNew */ inline __fastcall virtual TQReportEditor(Classes::TComponent* AOwner, int 
		Dummy) : Forms::TForm(AOwner, Dummy) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomForm.Destroy */ inline __fastcall virtual ~TQReportEditor(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TQReportEditor(HWND ParentWindow) : Forms::TForm(
		ParentWindow) { }
	#pragma option pop
	
};


class DELPHICLASS TQREditor;
class PASCALIMPLEMENTATION TQREditor : public Controls::TWinControl 
{
	typedef Controls::TWinControl inherited;
	
private:
	TQReportEditor* QReportEditorForm;
	bool FShowMenu;
	bool __fastcall GetShowStatusLine(void);
	AnsiString __fastcall GetFilename();
	void __fastcall SetFilename(const AnsiString Value);
	TQReportEditor* __fastcall GetReportEditor(void);
	
protected:
	virtual void __fastcall SetParent(Controls::TWinControl* AControl);
	void __fastcall SetShowMenu(bool Value);
	void __fastcall SetShowStatusLine(bool Value);
	
public:
	__fastcall virtual TQREditor(Classes::TComponent* AOwner);
	__fastcall virtual ~TQREditor(void);
	__property AnsiString Filename = {read=GetFilename, write=SetFilename};
	__property TQReportEditor* ReportEditor = {read=GetReportEditor};
	
__published:
	__property bool ShowMenu = {read=FShowMenu, write=SetShowMenu, nodefault};
	__property bool ShowStatusLine = {read=GetShowStatusLine, write=SetShowStatusLine, nodefault};
	__property Align ;
	void __fastcall ShowEditor(void);
	void __fastcall NewReport(void);
	void __fastcall OpenReport(void);
	void __fastcall SaveReport(void);
	void __fastcall PrintReport(void);
	void __fastcall PreviewReport(void);
	void __fastcall SaveReportAs(void);
	void __fastcall ReportSettings(void);
	void __fastcall SelectData(void);
	void __fastcall Cut(void);
	void __fastcall Copy(void);
	void __fastcall Paste(void);
	HIDESBASE void __fastcall Show(void);
	void __fastcall OpenReportFile(AnsiString AFilename);
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TQREditor(HWND ParentWindow) : Controls::TWinControl(
		ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall RegisterEditorControl(TMetaClass* APrintableClass);

}	/* namespace Qreditor */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qreditor;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QREditor
